#include <iostream>     //библеотека потоков ввода/вывода в консоль
#include <vector>       //библиотека контейнера (динамического массива) "вектор"
using namespace std;    //пространство имен, тут хранятся имена всех типов данных и функций

//все аргументы по константной ссылке во избежании модификации и копирования
//-----------------------------------------------------------------------------
vector<int> getNumeraticRowWithStep(const int& from,
                                    const int& to,
                                    const int& stepSize)
//-----------------------------------------------------------------------------
{
    int counter;                     //переменная индекса, который будет использоваться при иттерации цикла
    vector<int> row;                 //вектор целых значений

    counter = from;                   //инициализируем индекс началом диапазона

    while (counter <= to)            //цикл до конца коллекции, включая последнее значение
    {
        row.push_back(counter);     //добавляем текущее значение на данной иттерации цикла в массив
        counter += stepSize;         //увеличиваем значение счётчика на размер заданого шага
    }

    return row;                    //возращаем разименованный указатель, т.е. сам объект, но уже по константной ссылке
}

////оснавная функция программы или точка входа в неё
//-----------------------------------------------------------------------------
int main()
//-----------------------------------------------------------------------------
{
    vector<int> numberCollection;   //коллекция елементов последовательности
    int rangeBorderFrom;            //тут храним левый предел последовательности
    int rangeBorderTo;              //тут храним правый предел последовательности
    int stepSize;                   //размер шага

    //инициализируем наши значения, относительно задания
    rangeBorderFrom = 1000;
    rangeBorderTo = 9999;
    stepSize = 3;

    //инициплизируем коллекцию возращаемым значением функции, передав в оную аргументы
    numberCollection = getNumeraticRowWithStep(rangeBorderFrom, rangeBorderTo, stepSize);

    cout << "Number sequence:" << endl;

    for (const int& currentValue : numberCollection)    //цикл по всей последовательности
    {
        cout << currentValue << endl;                   //выводим каждый елемент с новой строки
    }

    cout << "Total number count is: ";
    cout << numberCollection.size() << endl;            //выводим общее кол-во елементов последовательности

    cout << "Press any key to close program." << endl;

    system("pause");                                    //ставим программу "на паузу", до первого нажатия любой клавиши
    return 0;                                           //возращаем системе код 0, что значит, что программа завершила работу верно
}
